<template>
  <v-container class="forgot-password-container" fluid fill-height>
    <v-row no-gutters>
      <v-col cols="12">
        <v-card ref="forgot" class="forgot-password-content elevation-0 px-3 px-sm-7 px-md-5 py-5 py-sm-10 py-md-5 rounded" tile>
          <v-container class="mt-n16 mt-sm-n16 mt-md-0" fluid fill-height>
            <v-row justify="center" align="center">
              <v-col cols="12">
                <v-form ref="forgotForm" lazy-validation v-model="form.valid" @submit.prevent="reset">
                  <v-card class="d-flex flex-column elevation-0" style="height: 100%;">
                    <div class="mb-10">
                      <v-img class="mx-auto" max-width="200" :src="require('~/assets/images/logo.png')" contain></v-img>
                    </div>
                    <div class="text-center">
                      <h1>Set new password</h1>
                    </div>
                    <div class="d-flex flex-column">
                      <div class="form-container">
                        <p class="form-label">E-mail</p>
                        <v-text-field type="text" v-model="email" single-line outlined hide-details filled readonly></v-text-field>
                      </div>
                      <div class="form-container">
                        <p class="form-label">Authentication Key <span class="required-hint">*</span></p>
                        <v-text-field type="password" v-model="form.data.authkey" single-line outlined hide-details></v-text-field>
                      </div>
                      <div class="form-container">
                        <p class="form-label">Password <span class="required-hint">*</span></p>
                        <v-text-field v-model="form.data.password" single-line outlined hide-details :append-icon="show_password ? 'mdi-eye' : 'mdi-eye-off'" :type="show_password ? 'text' : 'password'" @click:append="show_password = !show_password"></v-text-field>
                      </div>
                      <div class="form-container">
                        <p class="form-label">Confirm Password <span class="required-hint">*</span></p>
                        <v-text-field v-model="form.data.password_confirmation" single-line outlined hide-details :append-icon="show_password ? 'mdi-eye' : 'mdi-eye-off'" :type="show_confirm_password ? 'text' : 'password'" @click:append="show_confirm_password = !show_confirm_password"></v-text-field>
                      </div>
                      <div>
                          <v-btn type="submit" block class="white--text" color="#291470" elevation="0" large :loading="form.loading">Reset password</v-btn>
                      </div>
                    </div>
                    <div class="mt-5 text-center">
                        <NuxtLink class="text-decoration-none" tag="a" :to="{ name: 'login' }">Back to log in</NuxtLink>
                    </div>
                    <div class="mt-5 mt-sm-8 mt-md-10 text-center">
                      <p class="mb-0">2021 NKTI. All rights reserved.</p>
                    </div>
                  </v-card>
                </v-form>
              </v-col>
            </v-row>
          </v-container>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import Form from 'vform'

export default {
  middleware: 'guest',

  layout: 'simple',

  data: () => ({
    show_password: false,
    show_confirm_password: false,
    remember: false,
    form : {
        valid : true,
        loading : false,
        data : {},
        rules : {
          authkey : [
            v => !!v || 'Authentication key is a required field.'
          ],
          password : [
            v => !!v || 'Password is a required field.'
          ],
          password_confirmation : [
            v => !!v || 'Confirm password is a required field.'
          ]
        }
      }
  }),

  computed: {
    email() {
      return this.$route.query.email
    }
  },

  watch: {
    '$vuetify.breakpoint.name'(v){
      if(v == 'xs' || v == 'sm'){
        this.$refs.forgot.$el.classList.add('small-device')
      }else{
        this.$refs.forgot.$el.classList.remove('small-device')
      }
    }
  },

  head () {
    return { title: this.$t('reset_password') }
  },

  created () {
    this.form.data.email = this.$route.query.email
    this.form.data.token = this.$route.params.token
  },

  methods: {
    async reset () {
      await this.$axios.post('/password/reset', this.form.data)
        .then(({ data }) => {
          //this.status = data.status
          //this.form.reset()
          this.$toast.open({
            message: 'Your password has been reset.',
            type: 'success',
            duration: 3000,
            pauseOnHover: true
          });
          setTimeout(()=>{
            this.$router.push({ name : 'login' })
          },3000)
        })
        .catch(err => {
            if(err.response.status == '403' || err.response.status == '422'){
              var x = ''
              this.$jquery.each(err.response.data.errors,(i,v) => {
                x += v + "<br>"
              })
              this.$toast.open({
                  message: x,
                  type: 'error',
                  duration: 3000,
                  pauseOnHover: true
              });
            }else if(err.response.status == '429'){
              this.$toast.open({
                  message: 'Too many attempts',
                  type: 'error',
                  duration: 3000,
                  pauseOnHover: true
              });
            }else{
              throw err.response.data
            }
        })
    }
  }
}
</script>

<style lang="scss" scoped>
  .forgot-password-container{
    background: #E5E5E5;
    margin: 0 auto;
    width: 100vw;
    .forgot-password-content {
      max-width: 600px;
      width: 90vw;
      margin: 0 auto;
    }
    .forgot-password-content.small-device {
      position: fixed;
      top: 0px;
      left: 0px;
      width: 100vw;
      height: 100vh;
    }
  }
</style>
